# Niver

Niver is a set of 3 network services:

* Public suffix registry
* Nameserver
* Static HTTP site hosting

## Demo

<https://niver.4.niv.re/>

## Status

I plan to create and maintain a public stable instance of Niver, but I haven't done so yet. Thus Niver is not yet tested with real world and long-term usages, and is **alpha software**.

## Detailed features

### Public suffix registry (`reg`)

* Register a subdomain of the registry
* Set domain's nameservers
* Set a DS record to enable DNSSEC
* Set Glue records
* Display your records

### Nameserver (`ns`)

* Host a zone on the server
* Zone file edition through `<textarea>`
* Dedicated forms to set/unset `A`, `AAAA`, `NS`, `TXT`, `CAA`, `SRV`, `MX`, `SRV`, `SSHFP`, `TLSA`, `CNAME`, `DNAME` and `LOC` records
* Display your records or the full zone file

### HTTP hosting (`ht`)

* Upload your site's files using SFTP
* Host a static site with a domain name and a Let's Encrypt certificate
* Host a static site with an Onion service (through Tor)

## Todo

See [the issue tracker](https://code.antopie.org/niver/niver/issues).

## Software used

[PHP](https://www.php.net/)
: main language

[SQLite](https://www.sqlite.org/index.html)
: accounts data storage

[Knot DNS](https://www.knot-dns.cz/)
: DNS server for both registry and DNS hosting

[sudo](https://www.sudo.ws/) 1.9.10+
: execute actions that match a regex as privileged or specific users

[SFTPGo](https://github.com/drakkan/sftpgo)
: upload sites files using SFTP

[nginx](https://nginx.org/)
: static HTTP server

Tor
: [Onion services](https://community.torproject.org/onion-services/)

[Certbot](https://certbot.eff.org/)
: get [Let's Encrypt](https://letsencrypt.org/) certificates for TLS

[GNU Core Utilities](https://www.gnu.org/software/coreutils/)
: manipulate the filesystem through sudo

## Installation

There is currently no proper documentation to install Niver, but you can create a system image or look at configuration files and scripts from [niver-mkosi](https://code.antopie.org/niver/niver-mkosi).

## Contribute

- Git repository : <https://code.antopie.org/niver/niver>
- Issue tracker : <https://code.antopie.org/niver/niver/issues>
- Matrix channel : [#niver:matrix.antopie.org](matrix:r/niver:matrix.antopie.org)

## Direct contact details

See <https://miraty.antopie.org/>.

## License

Niver is ethical libre software: you can use, redistribute or modify it under the terms of the CNPL-NAv7+ as found in LICENSE.md or at <https://git.pixie.town/thufie/npl-builder>.
