<?php

if (processForm()) {
	if (dirsStatuses('onion', 'http')[$_POST['dir']] !== false)
		output(403, 'Wrong value for <code>dir</code>.');

	rateLimit();

	// Add Tor config
	$torConf = 'HiddenServiceDir ' . CONF['ht']['tor_keys_path'] . '/' . $_SESSION['id'] . '/' . $_POST['dir'] . '/
	HiddenServicePort 80 [::1]:' . CONF['ht']['internal_onion_http_port'] . '
	';
	if (file_put_contents(CONF['ht']['tor_config_path'] . '/' . $_SESSION['id'] . '/' . $_POST['dir'], $torConf) === false)
		output(500, 'Failed to write new Tor configuration.');

	// Reload Tor
	exec(CONF['ht']['sudo_path'] . ' ' . CONF['ht']['tor_reload_cmd'], $output, $code);
	if ($code !== 0)
		output(500, 'Failed to reload Tor.');

	// Get the address generated by Tor
	exec(CONF['ht']['sudo_path'] . ' -u ' . CONF['ht']['tor_user'] . ' ' . CONF['ht']['cat_path'] . ' ' . CONF['ht']['tor_keys_path'] . '/' . $_SESSION['id'] . '/' . $_POST['dir'] . '/hostname', $output);
	$onion = $output[0];
	if (preg_match('/^[0-9a-z]{56}\.onion$/D', $onion) !== 1)
		output(500, 'No onion address found.');

	// Store it in the database
	addSite($_SESSION['id'], $_POST['dir'], $onion, 'onion', 'http');

	// Add Nginx config
	$nginxConf = 'server {
		listen [::1]:' . CONF['ht']['internal_onion_http_port'] . ';
		server_name ' . $onion . ';
		root ' . CONF['ht']['ht_path'] . '/' . $_SESSION['id'] . '/' . $_POST['dir'] . ';

		include inc/ht-onion.conf;
	}
	';
	if (file_put_contents(CONF['ht']['nginx_config_path'] . '/' . $onion . '.conf', $nginxConf) === false)
		output(500, 'Failed to write Nginx configuration.');

	// Reload Nginx
	exec(CONF['ht']['sudo_path'] . ' ' . CONF['ht']['nginx_reload_cmd'], result_code: $code);
	if ($code !== 0)
		output(500, 'Failed to reload Nginx.');

	// Tell the user their site address
	output(200, 'L\'adresse de votre service Onion HTTP est : <a href="http://' . $onion . '/"><code>http://' . $onion . '/</code></a>');
}

$dirsStatuses = dirsStatuses('onion', 'http');

?>

<p>
	Ajouter un accès en .onion sur un dossier
</p>

<form method="post">
	<label for="dir">Dossier ciblé</label><br>
	<select required="" name="dir" id="dir">
		<option value="" disabled="" selected="">---</option>
<?php
foreach ($dirsStatuses as $dir => $alreadyEnabled)
	echo '		<option' . ($alreadyEnabled ? ' disabled=""' : '') . ' value="' . $dir . '">' . $dir . '</option>' . LF;
?>
	</select>
	<br>
	<input value="Valider" type="submit">
</form>
